# --------------------------------------------------------------------
# tools.pm -- authored by paal@ekran.no, Mon Aug 28 11:19:49 CEST 2000 

# tools are generaly handy routines that does a specific job which is
# utilized in other parts of the code, some of these are quite
# recycable.

# -------------------------------------------------------------------
# change_expanded_state -- this 
sub tools_change_expanded_state()
{
	my ($uexpn)=@_;

    open TXT,"<".$i_cgiu; # read users' cgi file.
	while (<TXT>)
	{
		chomp;
		($P,$M)=split /=/,$_;
        if ($P eq '$u_expanded') # this is the EXPANDED option line
        {
            if ($uexpn==1) { $M="1;"; } else { $M="0;"; } # change state
            push @tmp,$P."=".$M."\n";
        } else {
            push @tmp,$_."\n";
        }
    }
    close TXT;

    open TXT,">".$i_cgiu; # now write back the cgi file
    foreach $line (@tmp) { print TXT $line; }
    close TXT;
}

# -------------------------------------
# check if header expansion is selected
# EXPANDED in user cgi is 0 when expanded
sub tools_expanded()
{
    my ($unam)=@_;
    my $P,$M;

    open TXT,"<".$i_cgiu;
    while (<TXT>)
    {
        chomp;
        ($P,$M)=split /=/,$_;
        if ($P eq "\$u_expanded") { $ret=$M; }
    }
    close TXT;
	chop $ret;
    return ($ret);
}

# -------------------------------------------------------------------
# get current folder (returns the name of the current folder)
sub get_current_folder()
{
    my $current;
    open TXT,$i_nmh."/folder |";
    $current=<TXT>;
    close TXT;

    chomp $current;
    return ($current);
}

# --------------------------------------------------------------
# returns a list with ids for all the messages in current folder
sub get_msg_list()
{
	my $id;
 	my @msglst;

	open TXT,$i_nmh."/scan -reverse all -form ".$i_wmhome."/scan.ids |";
    while (<TXT>)
    {   
		chomp;
        $id=$_;
    	push @msglst,int($id);
    }
	close (TXT);
	return (@msglst);
}

# -------------------------------------------------------------------
# get plain folder receives a folder string and the name of the
# current folder then it returns the name of the folder in plain format
# eg: 
#   string                                     ->     returns
#   inbox+ has 6 messages  (5-18); cur=14.     ->     inbox
#   foo++  has 1 message   (1- 1); cur= 1.     ->     foo+
#   test   has 1 message   (1- 1); cur= 1.     ->     test

sub get_plain_folder()
{
    my ($fstr,$current)=@_;
    my $cnt,$cnt2;

    $cnt=0; $cnt2=0;

    # make substr($fstr,0,$cnt) the plain formated folder
    while (substr($fstr,$cnt,1) ne " ") { $cnt++ };

    while (substr($current,$cnt2,1) ne " ") { $cnt2++ };
    if (substr($fstr,0,$cnt) eq substr($current,0,$cnt2))
    {
        $cnt--; # we have a match, remove last +
    }
    return (substr($fstr,0,$cnt));
}


# -------------------------------------------------------------------
# get current message (returns the ID of the current message)
sub get_current_message()
{
    my $line,$cnt,$cntx;

    open TXT,$i_nmh."/show cur|";
    $line=<TXT>; # only grab the first line.
    close TXT;
    chomp $line; # remove LF
    chop $line;  # remove )

    $cnt=length($line); # the number should now be at the end of the string
    while ((substr($line,$cnt-1,1) ne ":") && ($cnt>0)) { $cnt--; $cntx++;}
    $line=substr($line,$cnt,$cntx);

    return ($line);
}

# -------------------------------------------------------------------
# recieves a string and returns a string which is HTML padded.
sub html_encode()        # some FIX for the HTML output
{
    ($line)=@_;

    $line=~ s/\&/\&amp;/g;
    $line=~ s/</&lt;/g;
    $line=~ s/>/&gt;/g;
	
	$_=$line;

	# make URLs hot-linkable.
	s{<URL:(.*?)>}	{<a href="$1" target="_top">$1</a>}gs ||
	s{(http:\S+)}   {<a href="$1" target="_top">$1</a>}gi;

	$line=$_;
    return ($line);
}

# -------------------------------------------------------------------
# wspc_cnt returns the number of whitespaces at the begining of a string
sub wspc_cnt()
{
    my ($str)=@_;
    my $cnt=0;
    while ((substr($str,$cnt,1) eq " ") || ($cnt>length($str))) { $cnt++; }
    return ($cnt);
}


# -------------------------------------------------------------------
# returns ID, date, from and subject line, based on received string and
# the format of scan all
sub parse_break() # returns id, date, from and subject from $line
{
    my ($line)=@_;
    my ($id,$dt,$from,$subj);
    my $cnt,$cntx;

    $cnt=0;
    while (substr($line,$cnt,1) eq " ") { $cnt++; }
    $cntx=$cnt;
    while ((substr($line,$cntx,1) ne " ") &&
           (substr($line,$cntx,1) ne "+")) { $cntx++; }

    $id=substr($line,$cnt,($cntx-$cnt));
    $dt=substr($line,$cntx+2,5);

    $cnt=12;
    $cntx=30;
    while (substr($line,$cntx,1) eq " ") { $cntx--; }
    $from=substr($line,$cnt,($cntx-$cnt)+1);
    $subj=substr($line,31,length($line)-31);
    return ($id,$dt,$from,$subj);
}

# ---------------------------------------------
# write debug information to a file on the disc
sub tools_debug()
{
	my ($i,$md)=@_;

	if ($md eq "a")
	{
		open DTA,">>debug.txt";
	} else {
		open DTA,">debug.txt";
	}

	print DTA $i;
	close DTA;
}

1;

