
# ------------------------------------------------------------------
# wmh.pm -- authored by paal@ekran.no, Mon Jul  3 14:06:23 CEST 2000

# wmh.pm contains the main section of webmh. webmh aims to be a complete
# web-mail solution based on nmh.

# TODO:

# -- group reply
# -- options handle
# -- config+skins handle
# -- MIME handle

use CGI qw(:cgi-lib);
# use HTML::Entities;

require "/its/trinket/webmh/html.pm";
require "/its/trinket/webmh/authenticate.pm";
require "/its/trinket/webmh/config.pm";
require "/its/trinket/webmh/folders.pm";
require "/its/trinket/webmh/display.pm";
require "/its/trinket/webmh/send.pm";
require "/its/trinket/webmh/tools.pm";

# -------------------------------------------------------------------

&ReadParse(*data);

# uact=
#       mhead=display message headers in top frame
#       mtail=display one message in bottom frame
#		compose=compose a message in both fields
#		dels=delete single message ($ushow==message)
#		movs=move single message ($SFOLDER==to folder, message ==current)
#		delMarked=Delete all marked messages
#		movMarked=Move all marked messages to specific folder
#		expand=expand header
# 		shrink=shrink header

$uact=$data{"UACT"};    # user action
$ushow=$data{"USHOW"};  # show  -- used to pass arguments between cgi-bin calls
$uflag=$data{"UFLAG"};  # flags -- used to pass arguments between cgi-bin calls
$ups=$data{"UPS"};	    # ups   -- used to pass text between cgi-bin calls

$sfolder=$data{"SFOLDER"}; # commonly used for selecting folders
$unam=$data{"UNAME"}; # global username
$upwd=$data{"UPWD"};  # global password

#
# -------------------------------------------------------------------
# Initialization

config_init();

$i_remote=$ENV{'REMOTE_HOST'};
if (!$i_remote) { $i_remote=$ENV{'REMOTE_ADDR'}; }
$i_date=`/bin/date`;

#
# -------------------------------------------------------------------
# user authentication handle

if ($uact eq "logout") { authenticate_logout(); }
if ($uact eq "login")  { $foo=authenticate_setcookie($unam,$upwd); }
$foo=authenticate_parse_cookie(); # check if we have cookie

if ($foo!=1) { authenticate_user(); } # writes the login screen

#
# -------------------------------------------------------------------
# Execute minor changes (change folders, mesg. header state, etc)

if (($sfolder) && ($data{"CFOLDER"} eq "ok") && ($uact eq ""))
{
	system ($i_nmh."/folder +".$sfolder." >/dev/null");
}

if (($uact eq "expand") || ($uact eq "shrink"))
{
	if ($uact eq "expand")
	{		
		tools_change_expanded_state(1);
	} else {
		tools_change_expanded_state(0);
	}
	$uact=""; $ushow="";
}

if ($uact eq "movs") # move single message to a folder
{
	system $i_nmh."/refile cur +".$sfolder;
	$uact=""; 
	$ups="Message%20moved%20to%20".$sfolder.".";
}

if ($uact eq "dels")
{
	system $i_nmh."/rmm ".$ushow;
	$uact=""; $ushow="";
	$ups="Message%20deleted.";
}

if ($data{"delMarked"}) # multi-delete selected messages
{
	(@msglst)=get_msg_list(); # get lst of msgs in this folder
	foreach $id (@msglst)
	{
		if ($data{"d".$id}) # if this message is tagged, delete it.
		{
		    system $i_nmh."/rmm ".$id;
		}
	}
	$uact="mhead";
}

if ($uact eq "movMarked") # multi-delete selected messages
{
	(@msglst)=get_msg_list(); # get lst of msgs in this folder
	foreach $id (@msglst)
	{
		if ($data{"d".$id}) # if this message is tagged, delete it.
		{
			system $i_nmh."/refile ".$id." +".$sfolder;
		}
	}
	$uact="mhead";
}

#
# -------------------------------------------------------------------
# MAIN

print &PrintHeader;

if (($uact eq "") && ($ushow eq "")) # display main root frame
{
	system ("export MAILDROP=$u_maildrop; ".$i_nmh."/inc > /dev/null");
	print &html_display_root_frame();
	exit 0;
}
if ($uact eq "menu") { $c_body=$c_mbody; } # blue background on sidebar menu
if ($ushow!=1) { print &html_head(); }

if ($uact eq "compose")
{
	if ($ushow==1)
	{
    	print &html_display_root_frame_2F($uact,$uflag); exit 0;
	}
	if ($ushow==2) { print &send_display_compose_frame($uflag); }
	if ($ushow==3) { send_display_compose_send(); }
}

if ($uact eq "folders")
{
	if ($ushow==1)
	{
	    print &html_display_root_frame_2F($uact,$uflag); exit 0;
	}
	if ($ushow==2) { folders_main(); }
	if ($ushow==3) { folders_handle($data{"NFOLDER"},$uflag); }
}

if ($uact eq "menu") { print &html_display_menu(); } # sidebar menu
if ($uact eq "mhead") { print &display_headers(); }       # display msg. top
if ($uact eq "mtail") { print &display_message($ushow,$ups); } # dsp msg bottom 

print &html_tail();
exit 0;

1;
